package net.kelsoncraft.test;

import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.fabric.api.event.player.UseItemCallback;
import net.fabricmc.fabric.api.item.v1.FabricItemSettings;
import net.fabricmc.fabric.mixin.client.rendering.EntityRenderersMixin;
import net.kelsoncraft.test.item.CustomItems;
import net.minecraft.client.render.entity.EntityRendererFactory;
import net.minecraft.client.render.entity.LightningEntityRenderer;
import net.minecraft.entity.EntityType;
import net.minecraft.entity.LightningEntity;
import net.minecraft.item.ItemStack;
import net.minecraft.predicate.entity.LightningBoltPredicate;
import net.minecraft.text.Text;
import net.minecraft.util.TypedActionResult;

public class KelsonCraftTestClient implements ClientModInitializer {
	@Override
	public void onInitializeClient() {

		// Code below came from https://www.reddit.com/r/fabricmc/comments/qyt3jg/comment/hls4vep/
		// This works, but it doesn't show the lightning strike.

		// This runs whenever a player right clicks with the ruby, which is set in the if statement
		UseItemCallback.EVENT.register((player, world, unused) ->{
			ItemStack mainHandItem = player.getMainHandStack(); // Get the item the player is holding in their main hand.
			if(player.getMainHandStack().getName().equals(Text.translatable("item.kelsoncraft-test.ruby"))){ // Check if item is a ruby.
				LightningEntity lightning = new LightningEntity(EntityType.LIGHTNING_BOLT, world); // Create the lightning bolt.
				world.spawnEntity(lightning); // Spawn the lightning entity


                // This might be a way to make the lightning render in, I'm not sure how to use the EntityRendererFactory.Context()
				//LightningEntityRenderer lightning1 = new LightningEntityRenderer(new EntityRendererFactory.Context());
			}
			return TypedActionResult.success(mainHandItem, true); // Return success and swing hand to show item use.
		});
		// This entrypoint is suitable for setting up client-specific logic, such as rendering.
	}
}